-- Test translate_surroundings_highlight
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(13);

set search_path to camper, public;

select has_function('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text']);
select function_lang_is('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'sql');
select function_returns('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'void');
select isnt_definer('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text']);
select volatility_is('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'volatile');
select function_privs_are('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'translate_surroundings_highlight', array['integer', 'text', 'text', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate surroundings_highlight cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ff00ff","a"};')
     , ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffff00","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
     , (3, 1, 'cover3.xpm', sha256('static char *s[]={"1 1 1 1","a c #ff00ff","a"};'))
     , (4, 1, 'cover4.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffff00","a"};'))
;

insert into surroundings_highlight (surroundings_highlight_id, company_id, media_id, name, description)
values (8, 1, 2, 'Highlight A', '<h2>One</h2>')
     , (9, 1, 3, 'Highlight B', '<h2>Two</h2>')
;

insert into surroundings_highlight_i18n (surroundings_highlight_id, lang_tag, name, description)
values (9, 'ca', 'destacatb', '<h2>dos</h2>')
;

select lives_ok(
	$$ select translate_surroundings_highlight(8, 'ca', 'Destacat A', null) $$,
	'Should be able to translate the first highlight'
);

select lives_ok(
	$$ select translate_surroundings_highlight(9, 'es', 'Destacado B', '<h2>Dos</h2>') $$,
	'Should be able to translate the second highlight'
);

select lives_ok(
	$$ select translate_surroundings_highlight(9, 'ca', 'Destacat B', '<h2>I dos</h2>') $$,
	'Should be able to overwrite the catalan translation of the second highlight'
);

select bag_eq(
	$$ select surroundings_highlight_id, lang_tag, i18n.name, i18n.description::text from surroundings_highlight_i18n as i18n join surroundings_highlight using (surroundings_highlight_id) $$,
	$$ values (8, 'ca', 'Destacat A', '')
	        , (9, 'ca', 'Destacat B', '<h2>I dos</h2>')
	        , (9, 'es', 'Destacado B', '<h2>Dos</h2>')
	$$,
	'Should have added and updated all translations.'
);


select *
from finish();

rollback;
